CREATE SCHEMA other_schema;
CREATE MERGE TABLE testme (a int, b varchar(32)) PARTITION BY RANGE ON (a);
ALTER TABLE testme SET SCHEMA other_schema;
ALTER TABLE other_schema.testme SET SCHEMA sys;
ALTER TABLE testme RENAME TO testme2;
ALTER TABLE testme2 RENAME TO testme;

SELECT COUNT(*) from table_partitions;
SELECT COUNT(*) from range_partitions;

CREATE TABLE subtable1 (a int, b varchar(32));
ALTER TABLE testme ADD TABLE subtable1 AS PARTITION FROM 5 TO 10;
SELECT COUNT(*) from table_partitions;
SELECT COUNT(*) from range_partitions;
ALTER TABLE testme ADD TABLE subtable1 AS PARTITION FROM 5 TO 10; --error

CREATE TABLE wrongtable (a int, b varchar(32), c real);
ALTER TABLE testme ADD TABLE wrongtable AS PARTITION FROM 5 TO 6; --error

CREATE TABLE subtable2 (a int, b varchar(32));
ALTER TABLE testme ADD TABLE subtable2 AS PARTITION IN ('0', '1', '2'); --error
ALTER TABLE testme ADD TABLE subtable2 AS PARTITION FROM 7 TO 9; --error
ALTER TABLE testme ADD TABLE subtable2 AS PARTITION FROM 5 TO 5; --error
ALTER TABLE testme DROP TABLE subtable2; --error

DROP TABLE subtable1; --error
ALTER TABLE testme SET SCHEMA other_schema; --error, changing schema not allowed while with child tables
ALTER TABLE subtable1 SET SCHEMA other_schema; --error, changing the schema shouldn't be allowed while part of a merge table
ALTER TABLE subtable1 RENAME TO subtable3; --error, renaming the table shouldn't be allowed while part of a merge table

ALTER TABLE testme DROP TABLE subtable1;
ALTER TABLE subtable1 SET SCHEMA other_schema;
ALTER TABLE testme ADD TABLE other_schema.subtable1 AS PARTITION FROM 4 TO 23; --error, all the tables must belong to the same schema
ALTER TABLE testme ADD TABLE subtable2 AS PARTITION FROM 5 TO 5;
ALTER TABLE testme DROP TABLE subtable2;

SELECT COUNT(*) from table_partitions;
SELECT COUNT(*) from range_partitions;

DROP TABLE testme;
DROP TABLE wrongtable;
DROP TABLE subtable2;
DROP SCHEMA other_schema CASCADE;

SELECT COUNT(*) from table_partitions;
SELECT COUNT(*) from range_partitions;
